      * ---------------------------------------------------
      *    LDAP Query Sample Program
      * ---------------------------------------------------
       Identification Division.
       Program-ID.  COBTEST.

       Data Division.
 
       Working-Storage Section.
       
       01 LDGA-AREA.
           03 AREA-LENGTH                 PIC S9(9) BINARY.     
           03 USER-ID                     PIC X(64).     
           03 SEARCH-FILTER               PIC X(128).     
           03 RET-CODE                    PIC S9(9) BINARY.
           03 LDAP-CODE                   PIC S9(9) BINARY.
           03 ATTR-COUNT                  PIC S9(4) BINARY.     
           03 ATTR-ENTRY OCCURS 2 TIMES.
             05 ATTR-NAME                 PIC X(64).           
             05 VALUE-LENGTH              PIC S9(4) BINARY.     
             05 VALUE-COUNT               PIC S9(4) BINARY.     
             05 VALUE-ENTRY OCCURS 16 TIMES.
                07 ATTR-VALUE             PIC X(128).                       

       
       01 IESLDGAB         PIC X(8) VALUE 'IESLDGAB'.
       Procedure Division.

           Move Length Of LDGA-AREA to AREA-LENGTH.
           Move 'ifranzki@de.ibm.com' to USER-ID.
           Move Spaces to SEARCH-FILTER.
           Move 0 to RET-CODE.
           Move 0 to LDAP-CODE.
           Move 2 to ATTR-COUNT.
           Move 'email' to ATTR-NAME(1).
           Move 128 to VALUE-LENGTH(1).
           Move 16 to VALUE-COUNT(1)
           Move Spaces to ATTR-VALUE(1 1)
           Move Spaces to ATTR-VALUE(1 2)
           Move 'dept' to ATTR-NAME(2).
           Move 128 to VALUE-LENGTH(2).
           Move 16 to VALUE-COUNT(2)
           Move Spaces to ATTR-VALUE(2 1)
           Move Spaces to ATTR-VALUE(2 2)

           CALL IESLDGAB USING BY REFERENCE LDGA-AREA.        

           Display RET-CODE.
           Display LDAP-CODE.
           Display ATTR-NAME(1).
           Display VALUE-COUNT(1).
           Display ATTR-VALUE(1 1).
           Display ATTR-VALUE(1 2).
           
           Display ATTR-NAME(2).
           Display VALUE-COUNT(2).
           Display ATTR-VALUE(2 1).
           Display ATTR-VALUE(2 2).
               
           Goback.







