      * ---------------------------------------------------
      *    LDAP Query Sample Program
      * ---------------------------------------------------
       Identification Division.
       Program-ID.  COBTEST2.

       Data Division.
 
       Working-Storage Section.
       
       01 LDGA-AREA.
           03 AREA-LENGTH                 PIC S9(9) BINARY.     
           03 USER-ID                     PIC X(64).     
           03 SEARCH-FILTER               PIC X(128).     
           03 RET-CODE                    PIC S9(9) BINARY.
           03 LDAP-CODE                   PIC S9(9) BINARY.
           03 ATTR-COUNT                  PIC S9(4) BINARY.     
           03 EMAIL-ATTR.
             05 EMAIL-ATTR-NAME           PIC X(64).         
             05 EMAIL-VALUE-LENGTH        PIC S9(4) BINARY.     
             05 EMAIL-VALUE-COUNT         PIC S9(4) BINARY.     
             05 EMAIL-VALUE1              PIC X(128).
             05 EMAIL-VALUE2              PIC X(128).
           03 DEPT-ATTR.
             05 DEPT-ATTR-NAME            PIC X(64).           
             05 DEPT-VALUE-LENGTH         PIC S9(4) BINARY.     
             05 DEPT-VALUE-COUNT          PIC S9(4) BINARY.     
             05 DEPT-VALUE                PIC X(128).
       
       01 IESLDGAB         PIC X(8) VALUE 'IESLDGAB'.
       Procedure Division.

           Move Length Of LDGA-AREA to AREA-LENGTH.
           Move 'ifranzki@de.ibm.com' to USER-ID.
           Move Spaces to SEARCH-FILTER.
           Move 0 to RET-CODE.
           Move 0 to LDAP-CODE.
           Move 2 to ATTR-COUNT.
           Move 'email' to EMAIL-ATTR-NAME.
           Move 128 to EMAIL-VALUE-LENGTH.
           Move 2 to EMAIL-VALUE-COUNT.
           Move Spaces to EMAIL-VALUE1.
           Move Spaces to EMAIL-VALUE2.
           Move 'dept' to DEPT-ATTR-NAME.
           Move 128 to DEPT-VALUE-LENGTH.
           Move 1 to DEPT-VALUE-COUNT.
           Move Spaces to DEPT-VALUE.

           CALL IESLDGAB USING BY REFERENCE LDGA-AREA.        

           Display RET-CODE.
           Display LDAP-CODE.
           Display EMAIL-ATTR-NAME.
           Display EMAIL-VALUE-COUNT.
           Display EMAIL-VALUE1.
           Display EMAIL-VALUE2.
           
           Display DEPT-ATTR-NAME.
           Display DEPT-VALUE-COUNT.
           Display DEPT-VALUE.
               
           Goback.







